;-------------------------------------------------------------------------------
; CoLib.inc   Common data, structures, functions and macros
;              to be used as a template for in-process com server objects
;
;  version 1.1
;
; Copyright (c) 9/28/00  Ernest Murphy
;
; revised 3/3/01 to simplify object creation and remove ObjectData.m_pEntry0 
; revised 3/1/01 to add DeclareVariant and remove m_ObjectSize from ObjectData
;					(now just requires SIZEOF ObjectData)
; revised 1/8/01 to include AggItem STRUCT (formerly in DllGetclassObject.asm)
;
; For educational use only. Any commercial re-use only by written license
;
;
;-------------------------------------------------------------------------------
sIID_IUnknown                   TEXTEQU      <{000000000H, 00000H, 00000H, {0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}>
sIID_IClassFactory              TEXTEQU      <{000000001H, 00000H, 00000H, {0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}>
sIID_IDispatch                  TEXTEQU      <{000020400H, 00000H, 00000H, {0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}>

IsEqualGUID PROTO :DWORD,:DWORD  ;inline in the sdk objbase.sdk


; standard dll exports
EntryDllMain            PROTO :DWORD, :DWORD, :DWORD
DllRegisterServer       PROTO
DllUnregisterServer     PROTO
DllCanUnloadNow         PROTO
DllGetClassObject       PROTO :DWORD, :DWORD, :DWORD

; standard interface implimentations

; IUnknown interface implimentations
;------------------ new ----------------------------------
Colib_QueryInterface          PROTO :DWORD, :DWORD, :DWORD
Colib_AddRef                  PROTO :DWORD
Colib_Release                 PROTO :DWORD
;-----------------------------------------------------------


; IDispatch interface implimentations
GetTypeInfoCount        PROTO :DWORD, :DWORD
GetTypeInfo             PROTO :DWORD, :DWORD, :DWORD, :DWORD
GetIDsOfNames           PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
Invoke_                 PROTO :DWORD, :DWORD, :DWORD, :DWORD, :WORD,  :DWORD, :DWORD, :DWORD, :DWORD

; Class Factory interface implimentations
Colib_CreateInstance          PROTO :DWORD, :DWORD, :DWORD, :DWORD
Colib_LockServer              PROTO :DWORD, :DWORD

; internal helper functions
SetSubKey               PROTO :DWORD, :DWORD, :DWORD
GetNextToken            PROTO
AddReplacements         PROTO :DWORD
GuardedDeleteKey        PROTO :DWORD, :DWORD
GetCachedTypeInfo       PROTO :DWORD, :DWORD, :DWORD
Write_Regedit_File      PROTO  :DWORD,  :DWORD 
UnWrite_Regedit_File 	PROTO  id:DWORD,  atype:DWORD 
UnRegister_TypeLib      PROTO
Register_Typelib        PROTO


; external helper functions
ComPtrAssign            PROTO :DWORD, :DWORD
ComQIPtrAssign          PROTO :DWORD, :DWORD, :DWORD

externdef       g_hModule:DWORD
externdef       g_hHeap:DWORD
externdef       g_ObjectCount:DWORD

		START STRUCT
			ppv dd  ?			;must be the first
			stsize dd ?	
			StartList dd ?	
			count dd ?					
		START ENDS	
	ZEROLOCALES MACRO dernierelocale:REQ
		mov eax, esp
		mov esp, ebp	; base page of calling procedure
		@@:
		push 0
		cmp esp, eax
		ja @B	
	ENDM	

.data 


TITRE008 DB "FindResource failed No TypeLib found",0
TITRE004 DB "FindResource IDS_TypeLib failed",0
TITRE005 DB "Typelib end not MSFT or LoadResource failed",0
TITRE006 DB "Unicode Failed",0
TITRE007 DB "LoadTypeLib Failed",0
TITRE000 DB "RegisterTypeLib failed ",0
TITRE002 DB "FindResource Failed registry keys",0
TITRE003 DB "script error, no top key",0
TITRE009 DB "UnRegisterTypeLib failed",0



